#include <SDL.h>
#include <gnome.h>
#include "g_ddraw.h"
#include "g_main.h"
#include "g_input.h"
#include "io.h"

static int njoy;

static SDL_Joystick **joys;

/* I can't be arsed with this bloody ridiculous contraption!
 * Whose idea was this, anyway?
 * -- Gregg
 */

enum mybuttons {
	BTN_UP,
	BTN_DOWN,
	BTN_LEFT,
	BTN_RIGHT,
	BTN_A,
	BTN_B,
	BTN_C,
	BTN_X,
	BTN_Y,
	BTN_Z,
	BTN_START,
	BTN_MODE,
	BTN_TYPE,
	BTN_OFFSET
};

static unsigned int *inputs[] = {
	&Controller_1_Up,
	&Controller_1_Down,
	&Controller_1_Left,
	&Controller_1_Right,
	&Controller_1_A,
	&Controller_1_B,
	&Controller_1_C,
	&Controller_1_X,
	&Controller_1_Y,
	&Controller_1_Z,
	&Controller_1_Start,
	&Controller_1_Mode,
	&Controller_1_Type,
	
	&Controller_2_Up,
	&Controller_2_Down,
	&Controller_2_Left,
	&Controller_2_Right,
	&Controller_2_A,
	&Controller_2_B,
	&Controller_2_C,
	&Controller_2_X,
	&Controller_2_Y,
	&Controller_2_Z,
	&Controller_2_Start,
	&Controller_2_Mode,
	&Controller_2_Type,
	
	&Controller_1B_Up,
	&Controller_1B_Down,
	&Controller_1B_Left,
	&Controller_1B_Right,
	&Controller_1B_A,
	&Controller_1B_B,
	&Controller_1B_C,
	&Controller_1B_X,
	&Controller_1B_Y,
	&Controller_1B_Z,
	&Controller_1B_Start,
	&Controller_1B_Mode,
	&Controller_1B_Type,
	
	&Controller_1C_Up,
	&Controller_1C_Down,
	&Controller_1C_Left,
	&Controller_1C_Right,
	&Controller_1C_A,
	&Controller_1C_B,
	&Controller_1C_C,
	&Controller_1C_X,
	&Controller_1C_Y,
	&Controller_1C_Z,
	&Controller_1C_Start,
	&Controller_1C_Mode,
	&Controller_1C_Type,
	
	&Controller_1D_Up,
	&Controller_1D_Down,
	&Controller_1D_Left,
	&Controller_1D_Right,
	&Controller_1D_A,
	&Controller_1D_B,
	&Controller_1D_C,
	&Controller_1D_X,
	&Controller_1D_Y,
	&Controller_1D_Z,
	&Controller_1D_Start,
	&Controller_1D_Mode,
	&Controller_1D_Type,
	
	&Controller_2B_Up,
	&Controller_2B_Down,
	&Controller_2B_Left,
	&Controller_2B_Right,
	&Controller_2B_A,
	&Controller_2B_B,
	&Controller_2B_C,
	&Controller_2B_X,
	&Controller_2B_Y,
	&Controller_2B_Z,
	&Controller_2B_Start,
	&Controller_2B_Mode,
	&Controller_2B_Type,
	
	&Controller_2C_Up,
	&Controller_2C_Down,
	&Controller_2C_Left,
	&Controller_2C_Right,
	&Controller_2C_A,
	&Controller_2C_B,
	&Controller_2C_C,
	&Controller_2C_X,
	&Controller_2C_Y,
	&Controller_2C_Z,
	&Controller_2C_Start,
	&Controller_2C_Mode,
	&Controller_2C_Type,
	
	&Controller_2D_Up,
	&Controller_2D_Down,
	&Controller_2D_Left,
	&Controller_2D_Right,
	&Controller_2D_A,
	&Controller_2D_B,
	&Controller_2D_C,
	&Controller_2D_X,
	&Controller_2D_Y,
	&Controller_2D_Z,
	&Controller_2D_Start,
	&Controller_2D_Mode,
	&Controller_2D_Type,
	
};

static int Input_Active(unsigned int input)
{
	int joy, i;
	
	if (input >= 1024) {
		/* Joystick */
		joy = (input / 1024) - 1;
		input %= 1024;
		if (input >= 512) {
			/* Button */
			return ((int)SDL_JoystickGetButton(joys[joy], input-512));
		}
		/* FIXME: Hat support? */
		/* Axis */
		i = (int)SDL_JoystickGetAxis(joys[joy], input/2);
		if (input%2) i *= -1;
		/* FIXME: Adjustable sensitivity */
		return (i > 15000);
	} else {
		/* FIXME: kayboard */
		return(0);
	}
}

/* Notice that 0 in **inputs means the button is PRESSED. */
static inline void Update_Controller(int i)
{
	if (Input_Active(Keys_Def[i].Up)) {
		*(inputs[BTN_UP + (i * BTN_OFFSET)]) = 0;
		*(inputs[BTN_DOWN + (i * BTN_OFFSET)]) = 1;
	} else {
		*(inputs[BTN_UP + (i * BTN_OFFSET)]) = 1;
		if (Input_Active(Keys_Def[i].Down))
			*(inputs[BTN_DOWN + (i * BTN_OFFSET)]) = 0;
		else *(inputs[BTN_DOWN + (i * BTN_OFFSET)]) = 1;
	}
	
	if (Input_Active(Keys_Def[i].Left)) {
		*(inputs[BTN_LEFT + (i * BTN_OFFSET)]) = 0;
		*(inputs[BTN_RIGHT + (i * BTN_OFFSET)]) = 1;
	} else {
		*(inputs[BTN_LEFT + (i * BTN_OFFSET)]) = 1;
		if (Input_Active(Keys_Def[i].Right))
			*(inputs[BTN_RIGHT + (i * BTN_OFFSET)]) = 0;
		else *(inputs[BTN_RIGHT + (i * BTN_OFFSET)]) = 1;
	}
	
	*(inputs[BTN_START + (i * BTN_OFFSET)]) =
		Input_Active(Keys_Def[i].Start) ? 0 : 1;
	*(inputs[BTN_A + (i * BTN_OFFSET)]) =
		Input_Active(Keys_Def[i].A) ? 0 : 1;
	*(inputs[BTN_B + (i * BTN_OFFSET)]) =
		Input_Active(Keys_Def[i].B) ? 0 : 1;
	*(inputs[BTN_C + (i * BTN_OFFSET)]) =
		Input_Active(Keys_Def[i].C) ? 0 : 1;
	
	if (*(inputs[BTN_TYPE + (i * BTN_OFFSET)]) & 1) {
		*(inputs[BTN_MODE + (i * BTN_OFFSET)]) =
			Input_Active(Keys_Def[i].Mode) ? 0 : 1;
		*(inputs[BTN_X + (i * BTN_OFFSET)]) =
			Input_Active(Keys_Def[i].X) ? 0 : 1;
		*(inputs[BTN_Y + (i * BTN_OFFSET)]) =
			Input_Active(Keys_Def[i].Y) ? 0 : 1;
		*(inputs[BTN_Z + (i * BTN_OFFSET)]) =
			Input_Active(Keys_Def[i].Z) ? 0 : 1;
	}
}

void Update_Controllers()
{
	SDL_JoystickUpdate();
	if (Full_Screen) {
		if(SDL_JoystickGetButton(joys[0], 1)) {
			Toggle_FS();
		}
	}
	Update_Controller(0);
	Update_Controller(1);
	if (Controller_1_Type & 0x10) {
		/* Teamplayer, port 1 */
		Update_Controller(2);
		Update_Controller(3);
		Update_Controller(4);
	}
	if (Controller_2_Type & 0x10) {
		/* Teamplayer, port 2 */
		Update_Controller(5);
		Update_Controller(6);
		Update_Controller(7);
	}
}

/* What an unusual function! */

int String_Size(char *Chaine)
{
	int i = 0;
	
	while (*(Chaine + i++));
	
	return(i - 1);
}

struct K_Def Keys_Def[8] = {
	{'\r', 'v',
	'a', 's', 'd',
	'z', 'x', 'c',
	'j', 'k', 'h', 'l'},
	{'q', 'w',
	'e', 'r', 't',
	'y', 'u', 'i',
	'o', 'p', '[', ']'}
};

static gint keysnoop(GtkWidget *foo, GdkEventKey *ev, gpointer bar)
{
	printf("Key event: type %d, %s at %d ms, mods 0x%x, keyval 0x%x: %s\n",
		ev->type,
		ev->send_event ? "received" : "generated",
		ev->time,
		ev->state,
		ev->keyval,
		ev->string);
	return(0);
}

void Init_Input(void)
{
	int i;
	
	gtk_key_snooper_install(keysnoop, NULL);

	if(SDL_InitSubSystem(SDL_INIT_JOYSTICK)) {
		printf(_("\"Uhh.. no..\" -- Gefo"));
		exit(1);
	}
	njoy = SDL_NumJoysticks();
	if (njoy) {
		joys = g_malloc(njoy * sizeof(SDL_Joystick*));
		for(i = 0; i < njoy; i++)
			joys[i] = SDL_JoystickOpen(i);
	}
}
